#!/usr/bin/perl

use HTML::Template;
use CGI qw(:all);
use CGI ':cgi-lib';
use CGI::Carp qw(fatalsToBrowser);
use Time::Local;
use DBI;
use Net::SMTP;
use strict;

my $script_root = "/export/web/ipanalyze.broadviewnet.net/cgi-bin";
my $html_root = "/export/web/ipanalyze.broadviewnet.net/html/cust-int";
require "$script_root/cmanage_cookie.pl";
require "$script_root/cauthlib.pl";
my $version = "2.23";
my $script = $ENV{'SCRIPT_NAME'};
my $dbusername = 'ipanalyze';
my $dbpassword = 'ipchecker';
my $db = 'ipanalyze';
my $db_host = 'mysql.broadviewnet.net';
#Open a connection to the database at the start to avoid repetition
my $dbh = DBI->connect ("DBI:mysql:host=$db_host;database=$db", $dbusername, $dbpassword,{RaiseError => 1}) || die "ERROR connecting to database ::$DBI::errstr";

my $t = manage_cookie($dbh);
if ($t ne '1') {
	show_login();
	exit;
}

if (! param) {
	print header;
	show_login();
	exit;
 }

elsif (defined param('login_s')) {
		my @error;
		@error = check_login($dbh);
		if (@error) {
			print header;
			show_login();
			foreach (@error) {
			print "<p align=\"center\"><i><font color=\"#FF0000\"><b>$_</b></font></i></p>";
			}
		exit;
		}
		print header;
		print p"Login was a ok!!";
		#show_main('default',"",1);
		exit;
}
elsif (defined param('register')) {
	my $btn = param('btn');
	my $refid = param('referance_id');
	my $uname = param('username');
	my @error;
		if ($btn !~ /^[\d]{6}[A-Z0-9]{4}$/) {
			push @error , "Invalid ACCOUNT NUNMBER";
		}
		
		if ($refid !~ /^[A-Z]{3,3}\d{10,10}$/) {
			push @error , "Invalid Reference Id";
		}

		if ($uname !~ /^[A-Za-z-_]{4,8}/ ) {
			push @error, "Invalid Username must be between 4 and 8 characters and only characters  A thru Z and  - or _ may be used";
		}
	
	
	#If everything looks good lets make sure the username is not i the database already.
	my $sql = "SELECT username FROM `cusers` WHERE `username` = ?";
	my $sth = $dbh->prepare($sql);
	$sth->execute($uname) || die "ERROR: Could not connect to database :: $DBI::errstr";
	if (my $data = $sth->fetchrow_hashref) {
	$sth->finish;
	push @error , "Username is already in use please select another";
	}
	
	if (@error) {
		print header;
		show_register();
		foreach (@error) {
			print "<p align=\"center\"><i><font color=\"#FF0000\"><b>$_</b></font></i></p>";
		}
	exit;
	}
$sth->finish;
my $sql = "SELECT * FROM `data` WHERE reference_id = ? AND btn = ?";
my $sth = $dbh->prepare($sql);
$sth->execute($refid,$btn) || die "ERROR: Could not connect to database :: $DBI::errstr";
	if (my $data = $sth->fetchrow_hashref) {
		my @alphanumeric = ('a'..'z', 'A'..'Z', 0..9);
		my $randstring = join '', map $alphanumeric[rand @alphanumeric], 0..20;
		my $sql = "INSERT INTO cusers (username,btn,session_key) VALUES(?,?,?)";
		my $sth = $dbh->prepare($sql);
		$sth->execute($uname,$btn,$randstring) || die "ERROR: Could not connect to database :: $DBI::errstr";
		mailer($uname,$randstring,$btn,$data->{tech_email},$data->{company_name},$data->{reference_id});
	}
	
	else {
		print header;
		show_register();
		print "<p align=\"center\"><i><font color=\"#FF0000\"><b>The information supplied does not match our records, please contact Broadview Networks Technical Support at 1-800-BROADVIEW</b></font></i></p>";	
		exit;
	}

}

elsif (defined param('action')) {
	my $action = param('action');
	if ($action eq 'register') {
		print header;
		show_register();
		exit;
	}
}

else {
	print header;
	print "<p align=\"center\"><i><font color=\"#FF0000\"><b>Invalid Responce Sent to Server :: ERROR 404</b></font></i></p>"
}


sub show_login {
my $template = HTML::Template->new(filename => "$html_root/login.html");
$template->param(SCRIPT => $script);
print $template->output;
}

sub show_register {
my $template = HTML::Template->new(filename => "$html_root/register.html");
$template->param(SCRIPT => $script);
print $template->output;
}

sub mailer {
	my ($uname,$conf_id,$btn,$email,$company_name,$reference_id) = @_;
	my $mailhost = 'smtp.broadviewnet.net';
	my $from ='ipanalyze@ipmonitor.broadviewnet.net';
	my $to = $email;
	my $subject = "IP Network Managment Password";
	my $smtp = Net::SMTP-> new ($mailhost);
	$smtp ->mail($from);
	$smtp ->to($to);
	$smtp ->data();
	$smtp ->datasend ("To:$to\n");
	$smtp ->datasend ("From:$from\n");
	$smtp ->datasend ("Subject:$subject\n");
	$smtp ->datasend ("X-REFID: $reference_id\n");
	$smtp ->datasend ("\n");
	open (RV, "new_reg") || die "ERROR::cannot open warn_new_reg $!";
	while (<RV>) {
	$smtp->datasend("$_");
	}
	$smtp->datasend("\nPlease confirm your request by clicking on the link below\n\n");
	$smtp->datasend("http:\/\/ipanalyze.broadviewnet.net/cgi-bin/manage_network.pl\n");
	$smtp->datasend("\nConfirmation code - $conf_id \n\n");
	$smtp->datasend("NOTE:: This message has been sent from an automated account.\nIf you have questions about this e-mail please call Broadview at 1-800-BROADVIEW.\nYou can also reach Broadview by e-mail at support\@broadviewnet.net\n");
	$smtp->dataend();
	$smtp->quit;
	return;
}